﻿using FurnitureAssemblyContracts.BusinessLogicsContracts;
using FurnitureAssemblyContracts.ViewModels;
using FurnitureAssemblyDataModels.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace FurnitureAssemblyView
{
    public partial class FormFurnitureWorkpiece : Form
    { 
            private readonly List<WorkpieceViewModel>? _list;
            public int Id
            {
                get
                {
                    return
           Convert.ToInt32(comboBoxWorkpiece.SelectedValue);
                }
                set
                {
                    comboBoxWorkpiece.SelectedValue = value;
                }
            }
            public IWorkpieceModel? WorkpieceModel
            {
                get
                {
                    if (_list == null)
                    {
                        return null;
                    }
                    foreach (var elem in _list)
                    {
                        if (elem.Id == Id)
                        {
                            return elem;
                        }
                    }
                    return null;
                }
            }
        public int Count
            {
                get { return Convert.ToInt32(textBoxCount.Text); }
                set
                { textBoxCount.Text = value.ToString(); }
            }
            public FormFurnitureWorkpiece(IWorkpieceLogic logic)
            {
                InitializeComponent();
                _list = logic.ReadList(null);
                if (_list != null)
                {
                    comboBoxWorkpiece.DisplayMember = "WorkpieceName";
                    comboBoxWorkpiece.ValueMember = "Id";
                    comboBoxWorkpiece.DataSource = _list;
                    comboBoxWorkpiece.SelectedItem = null;
                }
            }
            private void ButtonSave_Click(object sender, EventArgs e)
            {
                if (string.IsNullOrEmpty(textBoxCount.Text))
                {
                    MessageBox.Show("Заполните поле Количество", "Ошибка",
                   MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
                if (comboBoxWorkpiece.SelectedValue == null)
                {
                    MessageBox.Show("Выберите компонент", "Ошибка",
                   MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
                DialogResult = DialogResult.OK;
                Close();
            }
            private void ButtonCancel_Click(object sender, EventArgs e)
            {
                DialogResult = DialogResult.Cancel;
                Close();
            }
    }

}
