﻿using FurnitureAssemblyContracts.BindingModels;
using FurnitureAssemblyContracts.ViewModels;
using FurnitureAssemblyDataModels.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FurnitureAssemblyListImplement.Models
{
    internal class Workpiece : IWorkpieceModel
    {
        public int Id { get; private set; }
        public string WorkpieceName { get; private set; } = string.Empty;
         public double Cost { get; set; }
        public static Workpiece? Create(WorkpieceBindingModel? model)
        {
            if (model == null)
            {
                return null;
            }
            return new Workpiece()
            {
                Id = model.Id,
                WorkpieceName = model.WorkpieceName,
                Cost = model.Cost
            };
        }
        public void Update(WorkpieceBindingModel? model)
        {
            if (model == null)
            {
                return;
            }
            WorkpieceName = model.WorkpieceName;
            Cost = model.Cost;
        }
        public WorkpieceViewModel GetViewModel => new()
        {
            Id = Id,
            WorkpieceName = WorkpieceName,
            Cost = Cost
        };
    }
}
